searchNodes=[{"ref":"Sqlitex.html","title":"Sqlitex","module":"Sqlitex","type":"module","doc":"Sqlitex gives you a way to create and query SQLite databases. Basic Example iex&gt; {:ok, db} = Sqlitex.open(&quot;:memory:&quot;) iex&gt; Sqlitex.exec(db, &quot;CREATE TABLE t (a INTEGER, b INTEGER, c INTEGER)&quot;) :ok iex&gt; Sqlitex.exec(db, &quot;INSERT INTO t VALUES (1, 2, 3)&quot;) :ok iex&gt; Sqlitex.query(db, &quot;SELECT * FROM t&quot;) {:ok, [[a: 1, b: 2, c: 3]]} iex&gt; Sqlitex.query(db, &quot;SELECT * FROM t&quot;, into: %{}) {:ok, [%{a: 1, b: 2, c: 3}]} Configuration Sqlitex uses the Erlang library esqlite which accepts a timeout parameter for almost all interactions with the database. The default value for this timeout is 5000 ms. Many functions in Sqlitex accept a :db_timeout option that is passed on to the esqlite calls and also defaults to 5000 ms. If required, this default value can be overridden globally with the following in your config.exs: config :sqlitex, db_timeout: 10_000 # or other positive integer number of ms"},{"ref":"Sqlitex.html#close/2","title":"Sqlitex.close/2","module":"Sqlitex","type":"function","doc":""},{"ref":"Sqlitex.html#create_table/5","title":"Sqlitex.create_table/5","module":"Sqlitex","type":"function","doc":"Create a new table name where table_opts is a list of table constraints and cols is a keyword list of columns. The following table constraints are supported: :temp and :primary_key. Example: [:temp, {:primary_key, [:id]}] Columns can be passed as: name: :type name: {:type, constraints} where constraints is a list of column constraints. The following column constraints are supported: :primary_key, :not_null and :autoincrement. Example: id: :integer, name: {:text, [:not_null]}"},{"ref":"Sqlitex.html#exec/3","title":"Sqlitex.exec/3","module":"Sqlitex","type":"function","doc":""},{"ref":"Sqlitex.html#open/2","title":"Sqlitex.open/2","module":"Sqlitex","type":"function","doc":""},{"ref":"Sqlitex.html#query/3","title":"Sqlitex.query/3","module":"Sqlitex","type":"function","doc":""},{"ref":"Sqlitex.html#query!/3","title":"Sqlitex.query!/3","module":"Sqlitex","type":"function","doc":""},{"ref":"Sqlitex.html#query_rows/3","title":"Sqlitex.query_rows/3","module":"Sqlitex","type":"function","doc":""},{"ref":"Sqlitex.html#query_rows!/3","title":"Sqlitex.query_rows!/3","module":"Sqlitex","type":"function","doc":""},{"ref":"Sqlitex.html#set_update_hook/3","title":"Sqlitex.set_update_hook/3","module":"Sqlitex","type":"function","doc":"Sets a PID to recieve notifications about table updates. Messages will come in the shape of: {action, table, rowid} action -&gt; :insert | :update | :delete table -&gt; charlist of the table name. Example: &#39;posts&#39; rowid -&gt; internal immutable rowid index of the row. This is NOT the id or primary key of the row. See the official docs."},{"ref":"Sqlitex.html#with_db/3","title":"Sqlitex.with_db/3","module":"Sqlitex","type":"function","doc":""},{"ref":"Sqlitex.html#t:connection/0","title":"Sqlitex.connection/0","module":"Sqlitex","type":"type","doc":""},{"ref":"Sqlitex.html#t:sqlite_error/0","title":"Sqlitex.sqlite_error/0","module":"Sqlitex","type":"type","doc":""},{"ref":"Sqlitex.html#t:string_or_charlist/0","title":"Sqlitex.string_or_charlist/0","module":"Sqlitex","type":"type","doc":""},{"ref":"Sqlitex.Query.html","title":"Sqlitex.Query","module":"Sqlitex.Query","type":"module","doc":""},{"ref":"Sqlitex.Query.html#query/3","title":"Sqlitex.Query.query/3","module":"Sqlitex.Query","type":"function","doc":"Runs a query and returns the results. Parameters db - A SQLite database. sql - The query to run as a string. opts - Options to pass into the query. See below for details. Options bind - If your query has parameters in it, you should provide the options to bind as a list. into - The collection to put results into. This defaults to a list. db_timeout - The timeout (in ms) to apply to each of the underlying SQLite operations. Defaults to Application.get_env(:sqlitex, :db_timeout) or 5000 ms if not configured. Returns [results...] on success {:error, _} on failure."},{"ref":"Sqlitex.Query.html#query!/3","title":"Sqlitex.Query.query!/3","module":"Sqlitex.Query","type":"function","doc":"Same as query/3 but raises a Sqlitex.QueryError on error. Returns the results otherwise."},{"ref":"Sqlitex.Query.html#query_rows/3","title":"Sqlitex.Query.query_rows/3","module":"Sqlitex.Query","type":"function","doc":"Runs a query and returns the results as a list of rows each represented as a list of column values. Parameters db - A SQLite database. sql - The query to run as a string. opts - Options to pass into the query. See below for details. Options bind - If your query has parameters in it, you should provide the options to bind as a list. db_timeout - The timeout (in ms) to apply to each of the underlying SQLite operations. Defaults to Application.get_env(:sqlitex, :db_timeout) or 5000 ms if not configured. Returns {:ok, %{rows: [[1, 2], [2, 3]], columns: [:a, :b], types: [:INTEGER, :INTEGER]}} on success {:error, _} on failure."},{"ref":"Sqlitex.Query.html#query_rows!/3","title":"Sqlitex.Query.query_rows!/3","module":"Sqlitex.Query","type":"function","doc":"Same as query_rows/3 but raises a Sqlitex.QueryError on error. Returns the results otherwise."},{"ref":"Sqlitex.QueryError.html","title":"Sqlitex.QueryError","module":"Sqlitex.QueryError","type":"exception","doc":""},{"ref":"Sqlitex.QueryError.html#message/1","title":"Sqlitex.QueryError.message/1","module":"Sqlitex.QueryError","type":"function","doc":"Callback implementation for Exception.message/1."},{"ref":"Sqlitex.Row.html","title":"Sqlitex.Row","module":"Sqlitex.Row","type":"module","doc":""},{"ref":"Sqlitex.Row.html#from/4","title":"Sqlitex.Row.from/4","module":"Sqlitex.Row","type":"function","doc":""},{"ref":"Sqlitex.Server.html","title":"Sqlitex.Server","module":"Sqlitex.Server","type":"module","doc":"Sqlitex.Server provides a GenServer to wrap a sqlitedb. This makes it easy to share a SQLite database between multiple processes without worrying about concurrency issues. You can also register the process with a name so you can query by name later. Unsupervised Example iex&gt; {:ok, pid} = Sqlitex.Server.start_link(&quot;:memory:&quot;, [name: :example]) iex&gt; Sqlitex.Server.exec(pid, &quot;CREATE TABLE t (a INTEGER, b INTEGER)&quot;) :ok iex&gt; Sqlitex.Server.exec(pid, &quot;INSERT INTO t (a, b) VALUES (1, 1), (2, 2), (3, 3)&quot;) :ok iex&gt; Sqlitex.Server.query(pid, &quot;SELECT * FROM t WHERE b = 2&quot;) {:ok, [[a: 2, b: 2]]} iex&gt; Sqlitex.Server.query(:example, &quot;SELECT * FROM t ORDER BY a LIMIT 1&quot;, into: %{}) {:ok, [%{a: 1, b: 1}]} iex&gt; Sqlitex.Server.query_rows(:example, &quot;SELECT * FROM t ORDER BY a LIMIT 2&quot;) {:ok, %{rows: [[1, 1], [2, 2]], columns: [:a, :b], types: [:INTEGER, :INTEGER]}} iex&gt; Sqlitex.Server.prepare(:example, &quot;SELECT * FROM t&quot;) {:ok, %{columns: [:a, :b], types: [:INTEGER, :INTEGER]}} # Subsequent queries using this exact statement will now operate more efficiently # because this statement has been cached. iex&gt; Sqlitex.Server.prepare(:example, &quot;INVALID SQL&quot;) {:error, {:sqlite_error, &#39;near &quot;INVALID&quot;: syntax error&#39;}} iex&gt; Sqlitex.Server.stop(:example) :ok iex&gt; :timer.sleep(10) # wait for the process to exit asynchronously iex&gt; Process.alive?(pid) false Supervised Example import Supervisor.Spec children = [ worker(Sqlitex.Server, [&quot;priv/my_db.sqlite3&quot;, [name: :my_db]) ] Supervisor.start_link(children, strategy: :one_for_one)"},{"ref":"Sqlitex.Server.html#child_spec/1","title":"Sqlitex.Server.child_spec/1","module":"Sqlitex.Server","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"Sqlitex.Server.html#create_table/4","title":"Sqlitex.Server.create_table/4","module":"Sqlitex.Server","type":"function","doc":""},{"ref":"Sqlitex.Server.html#exec/3","title":"Sqlitex.Server.exec/3","module":"Sqlitex.Server","type":"function","doc":""},{"ref":"Sqlitex.Server.html#init/1","title":"Sqlitex.Server.init/1","module":"Sqlitex.Server","type":"function","doc":"Invoked when the server is started. start_link/3 or start/3 will block until it returns. args is the argument term (second argument) passed to start_link/3. Returning {:ok, state} will cause start_link/3 to return {:ok, pid} and the process to enter its loop. Returning {:ok, state, timeout} is similar to {:ok, state} except handle_info(:timeout, state) will be called after timeout milliseconds if no messages are received within the timeout. Returning {:ok, state, :hibernate} is similar to {:ok, state} except the process is hibernated before entering the loop. See c:handle_call/3 for more information on hibernation. Returning {:ok, state, {:continue, continue}} is similar to {:ok, state} except that immediately after entering the loop the c:handle_continue/2 callback will be invoked with the value continue as first argument. Returning :ignore will cause start_link/3 to return :ignore and the process will exit normally without entering the loop or calling c:terminate/2. If used when part of a supervision tree the parent supervisor will not fail to start nor immediately try to restart the GenServer. The remainder of the supervision tree will be started and so the GenServer should not be required by other processes. It can be started later with Supervisor.restart_child/2 as the child specification is saved in the parent supervisor. The main use cases for this are: The GenServer is disabled by configuration but might be enabled later. An error occurred and it will be handled by a different mechanism than the Supervisor. Likely this approach involves calling Supervisor.restart_child/2 after a delay to attempt a restart. Returning {:stop, reason} will cause start_link/3 to return {:error, reason} and the process to exit with reason reason without entering the loop or calling c:terminate/2. Callback implementation for GenServer.init/1."},{"ref":"Sqlitex.Server.html#prepare/3","title":"Sqlitex.Server.prepare/3","module":"Sqlitex.Server","type":"function","doc":"Prepares a SQL statement for future use. This causes a call to sqlite3_prepare_v2 to be executed in the Server process. To protect the reference to the corresponding sqlite3_stmt struct from misuse in other processes, that reference is not passed back. Instead, prepared statements are cached in the Server process. If a subsequent call to query/3 or query_rows/3 is made with a matching SQL statement, the prepared statement is reused. Prepared statements are purged from the cache when the cache exceeds a preset limit (20 statements by default). Returns summary information about the prepared statement. {:ok, %{columns: [:column1_name, :column2_name,... ], types: [:column1_type, ...]}} on success or {:error, {:reason_code, &#39;SQLite message&#39;}} if the statement could not be prepared."},{"ref":"Sqlitex.Server.html#query/3","title":"Sqlitex.Server.query/3","module":"Sqlitex.Server","type":"function","doc":""},{"ref":"Sqlitex.Server.html#query_rows/3","title":"Sqlitex.Server.query_rows/3","module":"Sqlitex.Server","type":"function","doc":""},{"ref":"Sqlitex.Server.html#set_update_hook/3","title":"Sqlitex.Server.set_update_hook/3","module":"Sqlitex.Server","type":"function","doc":""},{"ref":"Sqlitex.Server.html#start_link/2","title":"Sqlitex.Server.start_link/2","module":"Sqlitex.Server","type":"function","doc":"Starts a SQLite Server (GenServer) instance. In addition to the options that are typically provided to GenServer.start_link/3, you can also specify: stmt_cache_size: (positive_integer) to override the default limit (20) of statements that are cached when calling prepare/3. db_timeout: (positive_integer) to override :esqlite3&#39;s default timeout of 5000 ms for interactions with the database. This can also be set in config.exs as config :sqlitex, db_timeout: 5_000."},{"ref":"Sqlitex.Server.html#stop/1","title":"Sqlitex.Server.stop/1","module":"Sqlitex.Server","type":"function","doc":""},{"ref":"Sqlitex.Server.StatementCache.html","title":"Sqlitex.Server.StatementCache","module":"Sqlitex.Server.StatementCache","type":"module","doc":"Implements a least-recently used (LRU) cache for prepared SQLite statements. Caches a fixed number of prepared statements and purges the statements which were least-recently used when that limit is exceeded."},{"ref":"Sqlitex.Server.StatementCache.html#new/2","title":"Sqlitex.Server.StatementCache.new/2","module":"Sqlitex.Server.StatementCache","type":"function","doc":"Creates a new prepared statement cache."},{"ref":"Sqlitex.Server.StatementCache.html#prepare/3","title":"Sqlitex.Server.StatementCache.prepare/3","module":"Sqlitex.Server.StatementCache","type":"function","doc":"Given a statement cache and an SQL statement (string), returns a tuple containing the updated statement cache and a prepared SQL statement. If possible, reuses an existing prepared statement. If not, prepares the statement and adds it to the cache, possibly removing the least-recently used prepared statement if the designated cache size limit would be exceeded. Will return {:error, reason} if SQLite is unable to prepare the statement."},{"ref":"Sqlitex.SqlBuilder.html","title":"Sqlitex.SqlBuilder","module":"Sqlitex.SqlBuilder","type":"module","doc":"This module contains functions for SQL creation. At the moment it is only used for CREATE TABLE statements."},{"ref":"Sqlitex.SqlBuilder.html#create_table/3","title":"Sqlitex.SqlBuilder.create_table/3","module":"Sqlitex.SqlBuilder","type":"function","doc":""},{"ref":"Sqlitex.Statement.html","title":"Sqlitex.Statement","module":"Sqlitex.Statement","type":"module","doc":"Provides an interface for working with SQLite prepared statements. Care should be taken when using prepared statements directly - they are not immutable objects like most things in Elixir. Sharing a statement between different processes can cause problems if the processes accidentally interleave operations on the statement. It&#39;s a good idea to create different statements per process, or to wrap the statements up in a GenServer to prevent interleaving operations. Example iex(2)&gt; {:ok, db} = Sqlitex.open(&quot;:memory:&quot;) iex(3)&gt; Sqlitex.query(db, &quot;CREATE TABLE data (id, name);&quot;) {:ok, []} iex(4)&gt; {:ok, statement} = Sqlitex.Statement.prepare(db, &quot;INSERT INTO data VALUES (?, ?);&quot;) iex(5)&gt; Sqlitex.Statement.bind_values(statement, [1, &quot;hello&quot;]) iex(6)&gt; Sqlitex.Statement.exec(statement) :ok iex(7)&gt; {:ok, statement} = Sqlitex.Statement.prepare(db, &quot;SELECT * FROM data;&quot;) iex(8)&gt; Sqlitex.Statement.fetch_all(statement) {:ok, [[id: 1, name: &quot;hello&quot;]]} iex(9)&gt; Sqlitex.close(db) :ok RETURNING Clause Support SQLite does not support the RETURNING extension to INSERT, DELETE, and UPDATE commands. (See https://www.postgresql.org/docs/9.6/static/sql-insert.html for a description of the Postgres implementation of this clause.) Ecto 2.0+ relies on being able to capture this information, so have invented our own implementation with the following syntax: ;--RETURNING ON [INSERT | UPDATE | DELETE] &lt;table&gt;,&lt;col&gt;,&lt;col&gt;,... When the prepare/2 and prepare!/2 functions are given a query that contains the above returning clause, they separate this clause from the end of the query and store it separately in the Statement struct. Only the portion of the query preceding the returning clause is passed to SQLite&#39;s prepare function. Later, when such a statement struct is passed to fetch_all/2 or fetch_all!/2 the returning clause is parsed and the query is performed with the following additional logic: SAVEPOINT sp_&lt;random&gt;; CREATE TEMP TABLE temp.t_&lt;random&gt; (&lt;returning&gt;); CREATE TEMP TRIGGER tr_&lt;random&gt; AFTER UPDATE ON main.&lt;table&gt; BEGIN INSERT INTO t_&lt;random&gt; SELECT NEW.&lt;returning&gt;; END; UPDATE ...; -- whatever the original statement was DROP TRIGGER tr_&lt;random&gt;; SELECT &lt;returning&gt; FROM temp.t_&lt;random&gt;; DROP TABLE temp.t_&lt;random&gt;; RELEASE sp_&lt;random&gt;; A more detailed description of the motivations for making this change is here: https://github.com/jazzyb/sqlite_ecto/wiki/Sqlite.Ecto&#39;s-Pseudo-Returning-Clause"},{"ref":"Sqlitex.Statement.html#bind_values/3","title":"Sqlitex.Statement.bind_values/3","module":"Sqlitex.Statement","type":"function","doc":"Binds values to a Sqlitex.Statement. Parameters statement - The statement to bind values into. values - A list of values to bind into the statement. Also accepts the following keyword options: db_timeout - The time in ms allowed for the statement to run. Defaults to 5000, or the :db_timeout value in Application env. Returns {:ok, statement} on success See :esqlite3.prepare for errors. Value transformations Some values will be transformed before insertion into the database. nil - Converted to :undefined true - Converted to 1 false - Converted to 0 datetime - Converted into a string. See datetime_to_string %Decimal - Converted into a number."},{"ref":"Sqlitex.Statement.html#bind_values!/3","title":"Sqlitex.Statement.bind_values!/3","module":"Sqlitex.Statement","type":"function","doc":"Same as bind_values/3 but raises a Sqlitex.Statement.BindValuesError on error. Returns the statement otherwise."},{"ref":"Sqlitex.Statement.html#exec/2","title":"Sqlitex.Statement.exec/2","module":"Sqlitex.Statement","type":"function","doc":"Runs a statement that returns no results. Should be called after the statement has been bound. Parameters statement - The statement to run. Also accepts the following keyword options: db_timeout - The time in ms allowed for the statement to run. Defaults to 5000, or the :db_timeout value in Application env. Returns :ok {:error, error}"},{"ref":"Sqlitex.Statement.html#exec!/2","title":"Sqlitex.Statement.exec!/2","module":"Sqlitex.Statement","type":"function","doc":"Same as exec/2 but raises a Sqlitex.Statement.ExecError on error. Returns :ok otherwise."},{"ref":"Sqlitex.Statement.html#fetch_all/2","title":"Sqlitex.Statement.fetch_all/2","module":"Sqlitex.Statement","type":"function","doc":"Fetches all rows using a statement. Should be called after the statement has been bound. Parameters statement - The statement to run. into - The collection to put the results into. Defaults to an empty list. Returns {:ok, results} {:error, error}"},{"ref":"Sqlitex.Statement.html#fetch_all!/2","title":"Sqlitex.Statement.fetch_all!/2","module":"Sqlitex.Statement","type":"function","doc":"Same as fetch_all/2 but raises a Sqlitex.Statement.FetchAllError on error. Returns the results otherwise."},{"ref":"Sqlitex.Statement.html#prepare/3","title":"Sqlitex.Statement.prepare/3","module":"Sqlitex.Statement","type":"function","doc":"Prepare a Sqlitex.Statement Parameters db - The database to prepare the statement for. sql - The SQL of the statement to prepare. Also accepts the following keyword options: db_timeout - The time in ms allowed for the statement to run. Defaults to 5000, or the :db_timeout value in Application env. Returns {:ok, statement} on success See :esqlite3.prepare for errors."},{"ref":"Sqlitex.Statement.html#prepare!/3","title":"Sqlitex.Statement.prepare!/3","module":"Sqlitex.Statement","type":"function","doc":"Same as prepare/3 but raises a Sqlitex.Statement.PrepareError on error. Returns a new statement otherwise."},{"ref":"Sqlitex.Statement.html#time_to_string/1","title":"Sqlitex.Statement.time_to_string/1","module":"Sqlitex.Statement","type":"function","doc":""},{"ref":"Sqlitex.Statement.BindValuesError.html","title":"Sqlitex.Statement.BindValuesError","module":"Sqlitex.Statement.BindValuesError","type":"exception","doc":""},{"ref":"Sqlitex.Statement.BindValuesError.html#message/1","title":"Sqlitex.Statement.BindValuesError.message/1","module":"Sqlitex.Statement.BindValuesError","type":"function","doc":"Callback implementation for Exception.message/1."},{"ref":"Sqlitex.Statement.ExecError.html","title":"Sqlitex.Statement.ExecError","module":"Sqlitex.Statement.ExecError","type":"exception","doc":""},{"ref":"Sqlitex.Statement.ExecError.html#message/1","title":"Sqlitex.Statement.ExecError.message/1","module":"Sqlitex.Statement.ExecError","type":"function","doc":"Callback implementation for Exception.message/1."},{"ref":"Sqlitex.Statement.FetchAllError.html","title":"Sqlitex.Statement.FetchAllError","module":"Sqlitex.Statement.FetchAllError","type":"exception","doc":""},{"ref":"Sqlitex.Statement.FetchAllError.html#message/1","title":"Sqlitex.Statement.FetchAllError.message/1","module":"Sqlitex.Statement.FetchAllError","type":"function","doc":"Callback implementation for Exception.message/1."},{"ref":"Sqlitex.Statement.PrepareError.html","title":"Sqlitex.Statement.PrepareError","module":"Sqlitex.Statement.PrepareError","type":"exception","doc":""},{"ref":"Sqlitex.Statement.PrepareError.html#message/1","title":"Sqlitex.Statement.PrepareError.message/1","module":"Sqlitex.Statement.PrepareError","type":"function","doc":"Callback implementation for Exception.message/1."}]